unit TestForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Buttons;
type
  quest=record
   q,a,b,c,d:string;
  end;
  TForm1 = class(TForm)
    LB: TListBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    L1: TLabel;
    REd: TRichEdit;
    Timer: TTimer;
    RG: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure LBClick(Sender: TObject);
    procedure RGClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    t:tdatetime;//final hour of the test
    qn:byte;//number of all questions
    qt:byte;//number of questions in a test
    qs:set of byte;//set of random question numbers
    ans:array of byte;//array with numbers of answers
    trueans:array of byte;//array with true answers
    br:byte;//number of correct answers
    A:array of quest;//array of questions
    AllDone:Boolean;
    procedure FillStructures; //Initialiazing method
    procedure Finish; //Finilizing method
  end;

var
  Form1: TForm1;
  izmestvane:integer=-5;
  implementation

{$R *.dfm}
function decode(s:string):string;
var i:integer;
begin
  for i:=1 to length(s) do
   s[i]:=chr(ord(s[i])+izmestvane);
  result:=s;
end;

procedure TForm1.FillStructures;
var i,j,k:byte; qf:textfile;s:string;
begin
  randomize;qn:=50;qt:=20;
  setlength(ans,qt);
  setlength(trueans,qt);
  setlength(A,qt);
  qs:=[];
  for i:=1 to qt do
  begin
   repeat j:=random(qn) until not (j in qs);
   qs:=qs+[j];
  end;
  assignfile(qf,'TestKGP.cod');reset(qf); i:=0; k:=0;
  while not eof (qf) do
  begin
    if i in qs then
    begin
      readln(qf,s);s:=decode(s);
      j:=1;
      while not (s[j] in['A'..'z',''..'',''..'']) do
      begin s[j]:=' '; inc(j) end;
      s:=trim(s);
      A[k].q:=inttostr(k+1)+'. '+s;
      for j:=1 to 4 do
      begin
        readln(qf,s);s:=decode(s);
        s:=trim(s);
        if s[length(s)]='@' then
        begin s[length(s)]:=' '; trueans[k]:=j end;
        case j of
          1:A[k].a:=s;
          2:A[k].b:=s;
          3:A[k].c:=s;
          4:A[k].d:=s;
        end
      end;
      LB.Items.Add(A[k].q);
      inc(k);
    end else for j:=1 to 5 do readln(qf);
    inc(i)
  end;
  closefile(qf);
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  L1.Caption:= 'Time left:'+TimeToStr(t-time);
  if t-time<strtotime('0:00:30') then beep;
  if t<time then
  begin
    Timer.Enabled:=False;
    L1.Caption:='Time iz over!';
    ShowMessage('Time iz over');
    Finish;
    Close;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FillStructures;
  LBClick(Sender);
  L1.Caption:= ' :00:20:00';
  t:=strtotime('0:20:00');
  t:=t+time;
  Timer.Enabled:=True;
end;

procedure TForm1.LBClick(Sender: TObject);
var i:integer;
begin
  RG.Itemindex:=ans[LB.ItemIndex]-1;
  With LB,Items do
  begin
    for i:=0 to 2 do Red.Lines[i]:='';
    Red.Lines[0]:=A[ItemIndex].q;
    RG.Items[0]:=A[ItemIndex].a;
    RG.Items[1]:=A[ItemIndex].b;
    RG.Items[2]:=A[ItemIndex].c;
    RG.Items[3]:=A[ItemIndex].d;
    i:=trueans[ItemIndex]-1;
    if AllDone then RG.Items[i]:='x '+RG.Items[i];
  end;
end;

procedure TForm1.RGClick(Sender: TObject);
begin
   ans[LB.ItemIndex]:=RG.ItemIndex+1;
   LB.SetFocus;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var i:byte;
begin
   AllDone:=True;
   LB.Selected[LB.ItemIndex]:=False;
   for i:=0 to qt-1 do
    if ans[i]=0 then
    begin LB.Selected[i]:=true; AllDone:=False end;
   if AllDone then Finish
   else showmessage('You did not answer to the marked questions!')
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin Close end;

procedure TForm1.Finish;
var i:integer;
begin
    br:=0;AllDone:=True;
    for i:=0 to qt-1 do
     if ans[i]=trueans[i] then
     begin inc(br);LB.Selected[i]:=True end;
     showmessage('Thank you! You have '+inttostr(br)+' correct answers!');
     L1.Caption:=inttostr(br)+' correct answers!';
     Timer.Enabled:=False;
     RG.Enabled:=False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not AllDone then
  if MessageDlg('You did not answer to all questions! Quite the test?',
     mtConfirmation, [mbYes, mbNo], 0)<>mrYes then
     begin Action:=caNone;exit end;
  Finish;
  if MessageDlg('Do you want to see the correct answers (marked with x) before leaving?',
    mtConfirmation, [mbYes, mbNo], 0)=mrYes then
  begin Action:=caNone;exit end else Action:=caFree;
end;

end.
